#!/usr/bin/perl
#                 2011 Y.Senta
######################################

@QUERYARRAY;

$BASE1="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
$BASE2="abcdefghijklmnopqrstuvwxyz";
$BASE3="0123456789";
$BASE4="!#$%=-/.,;:+*@_|";

sub GetQuery {
    local $a;
    local $title;
    local $data;
    local $buffer;

    @QUERYARRAY=();

    if ($ENV{'REQUEST_METHOD'} eq "POST") {
	if ($ENV{'CONTENT_LENGTH'} > 51200) { 
	    #error
	} else {
	    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	}
    } else { 
	$buffer = $ENV{'QUERY_STRING'}; 
    }

    foreach $a (split (/&/, $buffer)) {
	($title, $data) = split(/=/, $a, 2);
	$data =~ tr/+/ /;
	$data =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	push(@QUERYARRAY, $title);
	push(@QUERYARRAY, $data);
    }
}

sub SearchQuery {
    local $i;
    for ($i = 0; $i < $#QUERYARRAY; $i += 2){
	if ($QUERYARRAY[$i] eq $_[0]){
	    return $QUERYARRAY[$i+1];
	}
    }
    return "";
}

###############################
GetQuery();
$len     = SearchQuery("len");
$ult     = SearchQuery("ult");
$llt     = SearchQuery("llt");
$nlt     = SearchQuery("nlt");
$mlt     = SearchQuery("mlt");

if ($len ne ""){
    if ($ult ne "" || $llt ne "" || $nlt ne "" || $mlt ne ""){
	$BASE = "";
	if ($ult ne ""){
	    $BASE .= $BASE1;
	}
	if ($llt ne ""){
	    $BASE .= $BASE2;
	}
	if ($nlt ne ""){
	    $BASE .= $BASE3;
	}
	if ($mlt ne ""){
	    $BASE .= $BASE4;
	}

	$BASE .= $BASE;
	$BASE .= $BASE;

	@dim=split(//, $BASE);
	$length=$#dim + 1;

	if ($len <= 0 || $len > $length){
	    $err = "Length too large or zero";
	} else {
	    $seedstr=$ENV{'REMOTE_ADDR'}. $ENV{'SERVER_NAME'};
	    @array = unpack("C*", $seedstr);
	    $sum=time;
	    $i=24;
	    while ($#array >= 0){
		$sum ^= (shift(@array) & 0xff) << $i;
		$i--;
		if ($i < 0){
		    $i=24;
		}
	    }
	    $sum += $$;
	    $sum += int(rand(10000000));
	    srand($sum);

	    for ($n=0;$n<5;$n++){
		for ($i=0;$i<$length; $i++){
		    $j=int(rand($len));
		    $tmp=@dim[$i];
		    @dim[$i]=@dim[$j];
		    @dim[$j]=$tmp;
		}
	    }
	    $out=join('', @dim);
	    $psw=substr($out, 0, $len);
	}
    } else {
	$err = "No checked";
    }
} else {
    $ult = "checked";
    $llt = "checked";
    $nlt = "checked";
    $len = "32";
}

printf ("Content-type: text/html\n\n");
printf ("<html>\n<head>\n");
printf ("<title>Random password generator</title>\n");
printf ("<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html\">");
printf ("</head><body>\n");
printf ("<H2>MkPass</H2><HR>");

printf "<FORM  ACTION=\"mkpass.cgi\" METHOD=\"get\">\n";
printf ("Length: <INPUT NAME=\"len\" VALUE = \"%d\" SIZE=10> &nbsp;\n", $len);
printf ("<INPUT TYPE=\"checkbox\" NAME=\"ult\" VALUE=\"checked\" %s> ABC... &nbsp;\n", $ult);
printf ("<INPUT TYPE=\"checkbox\" NAME=\"llt\" VALUE=\"checked\" %s> abc... &nbsp;\n", $llt);
printf ("<INPUT TYPE=\"checkbox\" NAME=\"nlt\" VALUE=\"checked\" %s> 012... &nbsp;\n", $nlt);
printf ("<INPUT TYPE=\"checkbox\" NAME=\"mlt\" VALUE=\"checked\" %s> +-*... &nbsp;\n", $mlt);
printf "<INPUT TYPE=\"submit\" VALUE=\"Make\">\n";
printf "</FORM>";

if ($psw ne ""){
    printf ("<center><table border><tr><td>%s</td></tr></table></center>\n", $psw);
}
if ($err ne ""){
    printf ("ERROR: %s\n", $err);
}
printf ("<HR><A HREF=\"../index.html\">Back</A>");
printf ("</BODY></HTML>\n");
